/*
 * TLim.h
 * Copyright (C) 2002 Jason Storm jms@tlim.net
 * Licensed under the GPL
 */






/* BEGIN USER OPTIONS */

/* VARFILE is where to put our database */
# define VARFILE "/var/run/tlim.dat"

/* ok_list is the list of ip's that bypass the tlim checks */
#define ok_list "/etc/mail/tlim.exempt"

/* DENY_MSG is the error spat out to users when tlim sanctions them */
#define DENY_MSG _("221 To prevent spam, we must limit the number of consecutive emails sent through our server.  Sorry!")

/* MAX250 is the maximum number of successful emails an ip can send in TIME550.
   The below example is set up to allow 5 emails sent in 10 seconds. */

#define MAX250 "5"
#define TIME250 "10"

/*  MAX550 and TIME550 regulate the number of emails can be sent to non-existent
    addresses before the IP gets sanctioned. */

#define MAX550 "5"
#define TIME550 "10"


/* END USER OPTIONS */


/* 

Some of the following code was crudely ripped from IPLimit, 
written by Frank DENIS aka Jedi/Sector One. 

I assure you that anything that strikes you as clumsy, hamfisted,
desperate, obtuse, or simply tard most likely is all that and more,
and almost certainly my own creation.  My apologies in advance
for this beasts uglyness but by god it works...

If you really are losing sleep over it, email me code revisions/clues
and I will be sure to give them a shake.

-Jason Storm

*/




FILE *fp1;
char oneword[100];
char *c;

# define LOGLINE 250
#define MAX_IP_LEN 24
#define MAX_PORTLEN 8
#define _(X) X





#include <stdlib.h>
#include <stdio.h>
#include <sys/wait.h>
#include <errno.h>
#include <netdb.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>

#include <sendmail.h>

typedef struct Cnx_ {
   char ip[MAX_IP_LEN];
   time_t stamp;
} Cnx;
typedef struct CnxListEntry_ {
   Cnx cnx;
   struct CnxListEntry_ *next;
} CnxListEntry;
static void slog(const char * const s)
{
   static char a;
   if (s == NULL) {
      if (a != 0) {
         closelog();
      }
   } else {
      if (a == 0) {
         a++;
      }
      syslog(LOG_WARNING, s);
   }
}

static void bootched(const char * const remote_ip,
                  const char * const s)
{
   static char line[LOGLINE];
   strncpy(line, "tlim violation: ", LOGLINE);
   strncat(line, remote_ip, LOGLINE - strlen(line));
   strncat(line, " ", LOGLINE - strlen(line));
   strncat(line, s, LOGLINE - strlen(line));
   slog(line);
}
FILE *unf;


/* BANG BANG BANG */
static void srvr (void) {

   const char * const remote_ip = anynet_ntoa(&RealHostAddr);
   int fp;
   Cnx tmp_cnx;
   CnxListEntry *cnx_list_first = NULL, *cnx_list_last = NULL;
   const CnxListEntry *cnx_list_scan;
   int nb_cnx = 0, nb_cnx_total = 0;
   int max_per_host;
   double timeout;
   const time_t stamp = time(NULL);

   if ((max_per_host = atoi(MAX550)) <= 0 ||
       (timeout = strtod(TIME550, NULL)) <= 0.0) {
      fputs(_("Invalid limits\n"), stderr);
   }
   if (remote_ip == NULL) {
     fputs(_("Remote IP not set ?!\n"), stderr);
   }
   if ((fp = open(VARFILE, O_RDONLY | O_NONBLOCK)) < 0) {
    perror(_("Can't read " VARFILE));
   }
   while (read(fp, &tmp_cnx, sizeof tmp_cnx) > 0) {
      CnxListEntry *new_entry;
      if (difftime(stamp, tmp_cnx.stamp) > timeout) {
         continue;
      }
      if ((new_entry = malloc(sizeof *new_entry)) == NULL) {
        perror(_("Malloc"));
         close(fp);
      }
      new_entry->cnx = tmp_cnx;
      new_entry->next = NULL;
      if (cnx_list_first == NULL) {
         cnx_list_first = cnx_list_last = new_entry;
      } else {
         cnx_list_last->next = new_entry;
         cnx_list_last = new_entry;
      }
   }
   cnx_list_scan = cnx_list_first;
   while (cnx_list_scan != NULL) {

/* HACKLE */
      if (strcmp(cnx_list_scan->cnx.ip, remote_ip) == 0) {
         nb_cnx_total++;
      }
      cnx_list_scan = cnx_list_scan->next;
   }
   close(fp);
   if ((fp = open(VARFILE, O_WRONLY | O_NONBLOCK)) < 0) {
      perror(_("Can't create " VARFILE));
   }
   if (flock(fp, LOCK_EX) < 0) {
     perror(_("Can't lock " VARFILE));
   }
   cnx_list_scan = cnx_list_first;
   while (cnx_list_scan != NULL) {
      write(fp, &cnx_list_scan->cnx, sizeof cnx_list_scan->cnx);
      cnx_list_scan = cnx_list_scan->next;
   }
   strncpy(tmp_cnx.ip, remote_ip, sizeof tmp_cnx.ip);
   tmp_cnx.stamp = stamp;
   write(fp, &tmp_cnx, sizeof tmp_cnx);
   if (flock(fp, LOCK_UN) < 0) {
       perror(_("Can't unlock " VARFILE));
   }
   close(fp);
if (nb_cnx_total == max_per_host) {
   
   bootched(remote_ip,
            _("is blackholed."));

     goto xa;
 
  }
/* MOESHA TIME */
   if (nb_cnx_total > max_per_host) {

    xa:
{
int tvar = 1;
fp1 = fopen(ok_list, "r");
while(fgets(oneword, sizeof(oneword), fp1) != NULL) {
        if(strstr(oneword, remote_ip) != NULL) {
        tvar = 0;
        }
}

if(tvar) {
      puts(DENY_MSG);
        fflush (stdout);
        puts(remote_ip);
        fflush (stdout);
{
        char prog[44];
        sprintf(prog, "%s %s %s", "/etc/mail/mailblock ", remote_ip, " &");
        execlp("/bin/sh", "sh", "-c", prog, (char *) 0);
}
}
}
}
}

/* BANG BANG BANG */
static void sexprawn (void) {

   const char * const remote_ip = anynet_ntoa(&RealHostAddr);
   int fp;
   Cnx tmp_cnx;
   CnxListEntry *cnx_list_first = NULL, *cnx_list_last = NULL;
   const CnxListEntry *cnx_list_scan;
   int nb_cnx = 0, nb_cnx_total = 0;
   int max_per_host;
   double timeout;
   const time_t stamp = time(NULL);

   if ((max_per_host = atoi(MAX250)) <= 0 ||
       (timeout = strtod(TIME250, NULL)) <= 0.0) {
      fputs(_("Invalid limits\n"), stderr);
   }
   if (remote_ip == NULL) {
     fputs(_("Remote IP not set ?!\n"), stderr);
   }
   if ((fp = open(VARFILE, O_RDONLY | O_NONBLOCK)) < 0) {
    perror(_("Can't read " VARFILE));
   }
   while (read(fp, &tmp_cnx, sizeof tmp_cnx) > 0) {
      CnxListEntry *new_entry;
      if (difftime(stamp, tmp_cnx.stamp) > timeout) {
         continue;
      }
      if ((new_entry = malloc(sizeof *new_entry)) == NULL) {
        perror(_("Malloc"));
         close(fp);
      }
      new_entry->cnx = tmp_cnx;
      new_entry->next = NULL;
      if (cnx_list_first == NULL) {
         cnx_list_first = cnx_list_last = new_entry;
      } else {
         cnx_list_last->next = new_entry;
         cnx_list_last = new_entry;
      }
   }
   cnx_list_scan = cnx_list_first;
   while (cnx_list_scan != NULL) {

/* HACKLE */
      if (strcmp(cnx_list_scan->cnx.ip, remote_ip) == 0) {
         nb_cnx_total++;
      }
      cnx_list_scan = cnx_list_scan->next;
   }
   close(fp);
   if ((fp = open(VARFILE, O_WRONLY | O_NONBLOCK)) < 0) {
      perror(_("Can't create " VARFILE));
   }
   if (flock(fp, LOCK_EX) < 0) {
     perror(_("Can't lock " VARFILE));
   }
   cnx_list_scan = cnx_list_first;
   while (cnx_list_scan != NULL) {
      write(fp, &cnx_list_scan->cnx, sizeof cnx_list_scan->cnx);
      cnx_list_scan = cnx_list_scan->next;
   }
   strncpy(tmp_cnx.ip, remote_ip, sizeof tmp_cnx.ip);
   tmp_cnx.stamp = stamp;
   write(fp, &tmp_cnx, sizeof tmp_cnx);
   if (flock(fp, LOCK_UN) < 0) {
       perror(_("Can't unlock " VARFILE));
   }
   close(fp);
if (nb_cnx_total == max_per_host) {

   bootched(remote_ip,
            _("is blackholed."));

     goto xa;

  }
/* MOESHA TIME */
   if (nb_cnx_total > max_per_host) {

    xa:
{
int tvar = 1;
fp1 = fopen(ok_list, "r");
while(fgets(oneword, sizeof(oneword), fp1) != NULL) {
        if(strstr(oneword, remote_ip) != NULL) {
        tvar = 0;
        }
}

if(tvar) {
      puts(DENY_MSG);
        fflush (stdout);
        puts(remote_ip);
        fflush (stdout);
{
        char prog[44];
        sprintf(prog, "%s %s %s", "/etc/mail/mailblock ", remote_ip, " &");
        execlp("/bin/sh", "sh", "-c", prog, (char *) 0);
}

}
}
}
}

